[HDU]4035 Maze 期望公式推导

Maze
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65768/65768 K (Java/Others)
Total Submission(s): 1419 Accepted Submission(s): 511
Special Judge

Problem Description
When wake up, lxhgww find himself in a huge maze.

The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.

Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come to that room).
What is the expect number of tunnels he go through before he find the exit?

Input
First line is an integer T (T ≤ 30), the number of test cases.

At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.

Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.

Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.

Output
For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape from the maze, output “impossible”.

Sample Input
3
3
1 2
1 3
0 0
100 0
0 100
3
1 2
2 3
0 0
100 0
0 100
6
1 2
2 3
1 4
4 5
4 6
0 0
20 30
40 30
50 50
70 10
20 60

Sample Output
Case 1: 2.000000
Case 2: impossible
Case 3: 2.895522

这道题公式推导很复杂, 虽然不难但是有一 个很巧的思路.
就是有的时候我们可以只用推导系数就能求出答案
我们要分析答案的期望转移到底需要什么东西.
有些东西你推不出来, 但是他不一定是答案所需要的.
以下是来自Stephen的推导过程, %%%%% .

有一颗树n个结点n-1条边,根结点为1
对于在点i下一步有3种情况:
1:被杀死回到点1 — 概率为ki
2:找到出口退出—-慨率为ei
3:沿着边进入下一个点
求从点1开始到退出的平均需要走的边数

/*
分析: 
对于点i: 
1,点i是叶子结点,则: 
E(i)=ki*E(1)+ei*0+(1-ki-ei)*(E(father)+1) 
=>E(i)=ki*E(1)+(1-ki-ei)*E(father)+(1-ki-ei) 
2,点i非叶子结点,则: 
E(i)=ki*E(1)+ei*0+(1-ki-ei)/m *(E(father)+1)+(1-ki-ei)/m*SUM(E(child)+1) 
=>E(i)=ki*E(1)+(1-ki-ei)/m *E(father)+(1-ki-ei)/m*SUM(E(child))+(1-ki-ei);//作为1式  

从公式可知求E(i)需要求到E(father),E(child) 
但这是很难求到的,因为即使是叶子结点也需要知道E(1),但是E(1)是未知的需要求的 

假设:E(i)=Ai*E(1)+Bi*E(father)+Ci;//作为2式 

所以:E(child)=Aj*E(1)+Bj*E(i)+Cj; 
=>SUM(E(child))=SUm(Aj*E(1)+Bj*E(i)+Cj); 
带入1式  
 =>E(i)=ki*E(1)+(1-ki-ei)/m *E(father)+(1-ki-ei)/m*SUm(Aj*E(1)+Bj*E(i)+Cj)+(1-ki-ei); 
 =>(1-(1-ki-ei)/m*SUM(Bj))*E(i)=(ki+(1-ki-ei)/m*SUM(Aj))*E(1)+(1-ki-ei)/m *E(father)+(1-ki-ei+(1-ki-ei)/m*SUM(cj)); 
 与上述2式对比得到: 
 Ai=(ki+(1-ki-ei)/m*SUM(Aj))       / (1-(1-ki-ei)/m*SUM(Bj)) 
 Bi=(1-ki-ei)/m                   / (1-(1-ki-ei)/m*SUM(Bj)) 
 Ci=(1-ki-ei+(1-ki-ei)/m*SUM(cj)) / (1-(1-ki-ei)/m*SUM(Bj)) 
 所以Ai,Bi,Ci只与i的孩子Aj,Bj,Cj和本身ki,ei有关 
 于是可以从叶子开始逆推得到A1,B1,C1 
 在叶子节点: 
 Ai=ki; 
 Bi=(1-ki-ei); 
 Ci=(1-ki-ei); 
 而E(1)=A1*E(1)+B1*0+C1; 
 =>E(1)=C1/(1-A1); 
*/ 
#include<stdio.h>
#include<cmath>
#include<cstring>
#define clear(a) memset(a, 0, sizeof(a))
const double eps = 1e-10;
const int maxn = 20005;
bool mark;
int h[maxn], num, T, n;
double k[maxn], e[maxn], a, b, c, A, B, C;
struct edge{ int nxt, v;}ee[maxn * 2];
inline void add(int u, int v){
    ee[++num].v = v, ee[num].nxt = h[u], h[u] = num;
    ee[++num].v = u, ee[num].nxt = h[v], h[v] = num;
}
void dfs(int u, int fa){
    int cnt = 0;
    double a = 0, b = 0, c = 0;
    for(int i = h[u]; i; i = ee[i].nxt){
        int v = ee[i].v;
        if(v == fa) continue;
        dfs(v, u);
        ++cnt;
        a += A;b += B; c += C;
    }
    if(fa) cnt ++;
    double p = (1 - k[u] - e[u]) / cnt;
    if(fabs(1 - p * b) < eps) {mark = true; return;}
    A = (k[u] + p * a) / (1 - p * b);
    B = p / (1 - p * b);
    C = (1 - e[u] - k[u] + p * c) / (1 - p * b);
}
int main(){
    scanf("%d", &T);
    for(int j = 1; j <= T; ++j){
        scanf("%d", &n);
        int x, y;
        for(int i = 1; i ^ n; ++i) scanf("%d%d", &x, &y), add(x, y);
        for(int i = 1; i <= n; ++i){
            scanf("%lf%lf", &k[i], &e[i]);
            k[i]/= 100, e[i] /= 100;
        }
        dfs(1, 0);
        if(fabs(A - 1) < eps || mark) printf("Case %d: impossible\n", j);
        else printf("Case %d: %0.6f\n", j, C / (1 - A));  
        clear(h), num = 0; mark = false;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值